export type ProcessEvent = {
  processType: string,
  phase: string,
  command?: string,
  content?: string,
  contentType?: string,
};

type ProcessEventCallback = (event: ProcessEvent) => void;

type ErrorEventCallback = (event: Error) => void;

export interface SummarizerEventEmitter extends NodeJS.EventEmitter {
  process(): void;
  on(eventType: 'process', callback: ProcessEventCallback): this;
  on(eventType: 'error', callback: ErrorEventCallback): this;
  on(eventType: 'end', callback: () => void): this;
}

export interface OpenAiParams {
  apiKey: string;
  organizationId?: string;
  model?: string;
  temperature?: number;
}

export interface CreateBaseSummarizerParams {
  url: string;
  language?: string;
  country?: string;
  openAiParams: OpenAiParams;
}
